%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                    PSG Type    PSG Object           Location in Problem Statement                          Class
%matrix_syi_data           data        matrix_syi           n/a                                                    double
%matrix_syi_vars           vars        matrix_syi           n/a                                                    cell
%matrix_xyi_norm_data      data        matrix_xyi_norm      n/a                                                    double
%matrix_xyi_norm_vars      vars        matrix_xyi_norm      n/a                                                    cell
%vector_qi_data            data        vector_qi            ksm_avg(matrix_xYi_norm, vector_Yi_norm, vector_qi)    double
%vector_yi_norm_data       data        vector_yi_norm       n/a                                                    double
%parameter_bound_data      data        parameter_bound      constraint: = parameter_bound                          double
%parameter_bound_1_data    data        parameter_bound_1    constraint: <= parameter_bound_1, linearize = 1        double
%parameter_alpha_data      data        parameter_alpha      cardn(parameter_alpha, matrix_sYi)                     double
%parameter_bound_2_data    data        parameter_bound_2    box: >= parameter_bound_2, <= parameter_bound_3        double
%parameter_bound_3_data    data        parameter_bound_3    box: >= parameter_bound_2, <= parameter_bound_3        double
%parameter_solver_data     data        parameter_solver     Solver: parameter_solver                               char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_syi_data,matrix_syi_vars,matrix_xyi_norm_data,matrix_xyi_norm_vars,vector_qi_data,vector_yi_norm_data,parameter_bound_data,parameter_bound_1_data,parameter_alpha_data,parameter_bound_2_data,parameter_bound_3_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_syi',matrix_syi_data,matrix_syi_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_xyi_norm',matrix_xyi_norm_data,matrix_xyi_norm_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_qi',vector_qi_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_yi_norm',vector_yi_norm_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'problem_KSMavg_heuristic, minimize',...
'linearize = 1',...
'  ksm_avg(matrix_xYi_norm, vector_Yi_norm, vector_qi)',...
'constraint: = parameter_bound',...
'  linear(matrix_sYi)',...
'constraint: <= parameter_bound_1, linearize = 1',...
'  cardn(parameter_alpha, matrix_sYi)',...
'box: >= parameter_bound_2, <= parameter_bound_3',...
'Solver: parameter_solver',...
'',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',parameter_bound_1_data);
problem_statement = strrep(problem_statement,'parameter_bound_2',parameter_bound_2_data);
problem_statement = strrep(problem_statement,'parameter_bound_3',parameter_bound_3_data);
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',parameter_bound_data);
problem_statement = strrep(problem_statement,'parameter_alpha',parameter_alpha_data);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

