%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%problem_KSMavg_heuristic, minimize
%linearize = 1
%ksm_avg(matrix_xYi_norm, vector_Yi_norm, vector_qi)
%constraint: = parameter_bound
%linear(matrix_sYi)
%constraint: <= parameter_bound_1, linearize = 1
%cardn(parameter_alpha, matrix_sYi)
%box: >= parameter_bound_2, <= parameter_bound_3
%Solver: parameter_solver
%
%
%Input variables:
%
%Inputs                    PSG Type    PSG Object           Location in Problem Statement                          Class
%matrix_syi_data           data        matrix_syi           n/a                                                    double
%matrix_syi_vars           vars        matrix_syi           n/a                                                    cell
%matrix_xyi_norm_data      data        matrix_xyi_norm      n/a                                                    double
%matrix_xyi_norm_vars      vars        matrix_xyi_norm      n/a                                                    cell
%vector_qi_data            data        vector_qi            ksm_avg(matrix_xYi_norm, vector_Yi_norm, vector_qi)    double
%vector_yi_norm_data       data        vector_yi_norm       n/a                                                    double
%parameter_bound_data      data        parameter_bound      constraint: = parameter_bound                          double
%parameter_bound_1_data    data        parameter_bound_1    constraint: <= parameter_bound_1, linearize = 1        double
%parameter_alpha_data      data        parameter_alpha      cardn(parameter_alpha, matrix_sYi)                     double
%parameter_bound_2_data    data        parameter_bound_2    box: >= parameter_bound_2, <= parameter_bound_3        double
%parameter_bound_3_data    data        parameter_bound_3    box: >= parameter_bound_2, <= parameter_bound_3        double
%parameter_solver_data     data        parameter_solver     Solver: parameter_solver                               char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\CS_Minimize_Kantorovich_distance\problem_KSMavg_with_Cardinality_heuristic\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_syi_data,matrix_syi_vars,matrix_xyi_norm_data,matrix_xyi_norm_vars,vector_qi_data,vector_yi_norm_data,parameter_bound_data,parameter_bound_1_data,parameter_alpha_data,parameter_bound_2_data,parameter_bound_3_data,parameter_solver_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
